import * as crypto from 'crypto';
export declare namespace ResourceNaming {
    enum NamingType {
        NO = 0,
        DEFAULT = 1,
        CUSTOM = 2
    }
    interface NoNaming {
        readonly type: NamingType.NO;
    }
    interface DefaultNaming {
        readonly type: NamingType.DEFAULT;
    }
    interface CustomNaming {
        readonly type: NamingType.CUSTOM;
        readonly names: {
            [key: string]: string;
        };
    }
    interface NamingOptions {
        readonly naming: NoNaming | DefaultNaming | CustomNaming;
    }
    function createRandomString(value: crypto.BinaryLike, length?: number): string;
    function naming(resourceNaming: NamingOptions, defaultNaming: {
        [p: string]: string | undefined;
    }): {
        naming: {
            [k: string]: string | undefined;
        };
    };
}
